package cn.com.infosec.asn1.pkcs;

import cn.com.infosec.asn1.ASN1Encodable;
import cn.com.infosec.asn1.ASN1EncodableVector;
import cn.com.infosec.asn1.ASN1OctetString;
import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.DERInteger;
import cn.com.infosec.asn1.DERObject;
import cn.com.infosec.asn1.DEROctetString;
import cn.com.infosec.asn1.DERSequence;
import java.math.BigInteger;

public class PKCS12PBEParams extends ASN1Encodable {
   DERInteger iterations;
   ASN1OctetString iv;

   public PKCS12PBEParams(byte[] salt, int iterations) {
      PKCS12PBEParams var10000 = this;
      PKCS12PBEParams var10001 = this;
      super();
      DEROctetString var3;
      var3 = new DEROctetString.<init>(salt);
      var10001.iv = var3;
      DERInteger var4;
      var4 = new DERInteger.<init>(iterations);
      var10000.iterations = var4;
   }

   public PKCS12PBEParams(ASN1Sequence seq) {
      this.iv = (ASN1OctetString)seq.getObjectAt(0);
      this.iterations = (DERInteger)seq.getObjectAt(1);
   }

   public static PKCS12PBEParams getInstance(Object obj) {
      if (obj instanceof PKCS12PBEParams) {
         return (PKCS12PBEParams)obj;
      } else if (obj instanceof ASN1Sequence) {
         return new PKCS12PBEParams((ASN1Sequence)obj);
      } else {
         throw new IllegalArgumentException("unknown object in factory: " + obj.getClass().getName());
      }
   }

   public BigInteger getIterations() {
      return this.iterations.getValue();
   }

   public byte[] getIV() {
      return this.iv.getOctets();
   }

   public DERObject toASN1Object() {
      ASN1EncodableVector var1;
      ASN1EncodableVector var10000 = var1 = new ASN1EncodableVector;
      var1.<init>();
      var1.add(this.iv);
      var10000.add(this.iterations);
      return new DERSequence(var1);
   }
}
